#!/usr/bin/python

# Template for 6th programming assignment
# DB2 - WS 2015/16

# IMPORTS:

# module to read linewise from standard input
import fileinput

# to access command-line parameter and standard input (see below)
import sys

# needed for ceil
import math

class Block:
    # constructor - tuples is an empty list by default
    def __init__(self, tuples=None):
        if tuples == None:
            self.tuples = []
        else:
            self.tuples = tuples

    # add tuple to block
    def add_tuple(self, vtuple):
        self.tuples.append(vtuple)
        print "ta %s" % vtuple

    # call this when you load a block from disk to buffer
    def load(self):
        print "bl %s" % (",".join([ str(v) for v in self.tuples ] ))

    # call this when you write a block from buffer to disk
    def finish(self):
        print "bw %s" % (",".join([ str(v) for v in self.tuples ] ))

    # return all the tuples of the block
    def get_tuples(self):
        return self.tuples

    # return tuple at position >index< in block
    def get_tuple(self, index):
        return self.tuples[index]

    # return number of tuples
    def size(self):
        return len(self.tuples)


# this is the main function
def main():
    # initialize an empty list of tuples
    # NOTE: this is similar to a Vector in Java
    tuplelist = []

    # Loop over each line from standard input and add each int to list of tuples
    for line in fileinput.input("-"):

        # There is a newline at the end of each line - get rid of it
        line_stripped = line.strip()

        # convert explicitly to ints
        key = int(line_stripped)

        # add to tuplelist
        tuplelist.append(key)
        

    # assign command-line arguments
    buffer_size = int(sys.argv[1])
    tuples_per_block = int(sys.argv[2])

    # create block objects
    blocks = []

    # Assign tuples to blocks
    # 
    # We use function range with the third step parameter:
    #     - if you call range(0,9,3), it returns 0, 3, 6
    #     - if you call range(0,10,3), it returns 0, 3, 6, 9
    for i in range(0,len(tuplelist), tuples_per_block):

        # get the next tuples_per_block number of tuples
        # note that less than tuples_per_block tuples might be returned in the last iteration
        blocktuples = tuplelist[i: i + tuples_per_block]

        # create block object with the tuples
        block = Block(blocktuples)

        # append block to list of blocks
        blocks.append(block)

    # call external sort function
    ext_sort(blocks, buffer_size, tuples_per_block)



# blocks: list of Block objects
# buffer_size: number of free pages in the buffer
# tuples_per_block: Number of tuples per Block
def ext_sort(blocks, buffer_size, tuples_per_block):
    raise Exception("NOT IMPLEMENTED")   


# the main function needs to be called explicitly
if __name__ == "__main__":
    main()
